/***************************************************************************
 *   Copyright (C) 2009 by Stanson <stanson@pangolin.ru>                   *
 *   GPL v3 code, read COPYING file                                        *
 **************************************************************************/

#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <limits.h>
#include <signal.h>

#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/ioctl.h>

#include <getopt.h>

// 
#define READ_VERSION		0x00
#define COLLECT_OSC_DATA	0x01
#define READ_OSC_DATA		0x02

int main(int argc, char *argv[])
{int			ret, fd, i, j;
 char			*prog;
 unsigned char		cmd = 0, data[256];
 static struct option long_options[] =
 {
   {"version", no_argument,       0, 'v'},
   {"read",    no_argument,       0, 'r'},
   {"help",    no_argument,       0, 'h'},
   {0, 0, 0, 0}
 };

	prog = strrchr(argv[0],'/');
	if(!prog) prog = argv[0];
	else      prog++;

	while ((ret = getopt_long (argc, argv, "vrh", long_options, NULL)) != -1)
	{
		switch(ret)
		{
			case 'v': cmd = READ_VERSION; break;
			case 'r': cmd = READ_OSC_DATA; break;
			case 'h':
			default:
				printf("Usage: %s [--help/-h] [--read/-r] [--version/-v]\n", prog);
				return 1;
		}
	}

	fd = open("/dev/usb/osc0", O_RDWR);
	if(fd != -1)
	{
		/*    */
		data[0] = READ_VERSION;
		write(fd, &data, 1);
		read(fd, &data, 2);
		fprintf(stderr,"Oscilloscope version: %x.%x\n",data[0],data[1]);

		switch(cmd)
		{
			case READ_OSC_DATA:
			        data[0] = COLLECT_OSC_DATA;
				write(fd, &data, 1);
				read(fd, &data, 1);
				fprintf(stdout, "Done, return %d\n", data[0]);
				for(i = 0; i < 4; i++)
				{
			    		data[0] = READ_OSC_DATA;
					data[1] = 1;
					write(fd, &data, 1);
					read(fd, &data, 64);
					for(j = 0; j < 64; j++) fprintf(stdout, "%02X ", data[j]);
					fprintf(stdout, "\n");
				}
				break;
		}
		close(fd);
	}
	else
	{
		fprintf(stderr,"Device is not connected\n");
	}
	return 0;
}
